#ifndef _GAMESETTINGS_H_
#define _GAMESETTINGS_H_

#include "allegro.h"
#include "InputObj.h"
#include "MusicSound.h"
#include "StartGameConfig.h"

//stores and retrieves
//screen
//controls
//sound volume
//directories
//high scores

class GameSettings {
 public:
  GameSettings ();

  int init (InputObj * iO, MusicSound * ms, StartGameConfig * sgc);
  
  int loadGraphicsSettings ();
  int saveGraphicsSettings ();
  int loadControls (InputObj * iO);
  int saveControls (InputObj * iO);
  int loadVolume (MusicSound * ms);
  int saveVolume (MusicSound * ms);
  int loadStartSettings ();
  int saveStartSettings ();

  int getColorDepth ();
  int getResX ();
  int getResY ();
  int getGfxDriver ();
  void setGfxSettings (int, int, int, int);
  
  ~GameSettings ();

 protected:
  int resX;
  int resY;
  int colorDepth;
  int gfxDriver;
};

#endif
