#ifndef _STARTGAMECONFIG_H_
#define _STARTGAMECONFIG_H_

#include "allegro.h"
#include "Loader.h"
#include <vector>
#include <string>
using namespace std;

class GameSettings;

class StartGameConfig {
 public:
  StartGameConfig (GameSettings *, Loader *);
  void go (int, int*);
  ~StartGameConfig ();
  void addCampName (string, string);
  void addCharName (string, string);
  string getCampName ();
  string getCharName ();

  static void redrawMenu ();
  static int my_button_proc (int, DIALOG *, int);
  static int my_list_proc (int, DIALOG *, int);
  static int startGame(void);
  static int toMain ();

  static char* getCharNames (int, int *);
  static char* getCampNames (int, int *);

  static void buttonChooseCamp (void);
  static void buttonChooseChar (void);

  static void chooseCamp (bool);
  static void chooseChar (bool);

  static GameSettings * gs;
  static Loader * l;
  static DIALOG dlog [];
  static int * mainMsg;
  static int bgColorR;
  static int bgColorB;
  static int bgColorG;

  static int settingsIndexChar;
  static int settingsIndexCamp;

 protected:
  static vector <string *> * campNames;
  static vector <string *> * campFileNames;
  static vector <string *> * campDesc;
  static vector <string *> * charNames;
  static vector <string *> * charFileNames;
  static vector <string *> * charDesc;
};

#endif
